*cd "C:\Shazam\AER"
cd "C:\Users\tim\Documents\AAA-economics\aaaa-People-current\denis lawrence\AER 2013-2018\Jan 2019"

log using "vc-out-med-BM-tim-23-01-19", replace

* AER VC SFA model and CIs
* Australia & NZ updated 1 year to 2017, Ontario updated 1 year to 2016
* use new Ontario spec taking account of amalgamations
version 11
clear
set more off
set maxiter 2000


* import excel "DNSPData AusNZOnt 1Nov2018x BM.xls", sheet("DNSP Med") firstrow
insheet using "DNSPData AusNZOnt 1Nov2018x BM.txt"
* variables are: EIID Year Country Opex PrOpex MaxDem RMDemand CustNum CircLen ShareUGC

summarize
correlate custnum circlen rmdemand

generate DNSP=0
replace DNSP=int(eiid/100) if country==1
replace DNSP=eiid-2000+13 if country==2
replace DNSP=eiid-3000+36 if country==3

xtset DNSP year

* adjust to calendar year
generate yr=year
replace yr=yr+0.5 if DNSP==3
replace yr=yr+0.5 if DNSP==8
replace yr=yr+0.5 if DNSP==9
replace yr=yr+0.5 if DNSP==11
replace yr=yr+0.5 if DNSP==13
replace yr=yr-0.25 if country==2
replace yr=yr+0.5 if country==3

* adjust base to 2012
replace propex=propex/1.242220559 if country==1
replace propex=propex/1.221665248 if country==2
replace propex=propex/1.162050691 if country==3

* adjust for PPPs in 2012
* Australia PPP = 1.527404363
* NZ PPP = 1.482877481
* Canada PPP = 1.249076963
* converting into Australian Dollar base
replace propex=propex*1.482877481/1.527404363 if country==2
replace propex=propex*1.249076963/1.527404363 if country==3

generate vc=opex/propex
generate lvc=log(vc)

generate ly2=log(custnum)
generate ly3=log(circlen)
generate ly4=log(rmdemand)

generate z1=shareugc

generate lz1=log(z1)

* delete years prior to 2012 (prior to 2011 for Ontario)
generate yr1=year
replace yr1=yr1+1.0 if country==3
drop if yr1 < 2012

* mean correct output data
qui reg ly2
predict mly2
replace ly2=ly2-mly2
qui reg ly3
predict mly3
replace ly3=ly3-mly3
qui reg ly4
predict mly4
replace ly4=ly4-mly4

generate cd2=0
replace cd2=1 if country==2
generate cd3=0
replace cd3=1 if country==3

generate ly1=0
generate ly22=ly2*ly2/2
generate ly33=ly3*ly3/2
generate ly44=ly4*ly4/2
generate ly23=ly2*ly3
generate ly24=ly2*ly4
generate ly34=ly3*ly4

* construct dummy variables
qui tabulate DNSP, gen(d)

generate yrcd2=yr*cd2
generate yrcd3=yr*cd3

* models with 3 outputs:

regress lvc ly2-ly4 lz1 yr yrcd2 yrcd3 cd2 cd3
regress lvc ly2-ly4 ly22 ly23 ly24 ly33 ly34 ly44 lz1 yr yrcd2 yrcd3 cd2 cd3

regress lvc ly2-ly4 lz1 yr yrcd2 yrcd3 cd2 cd3 d2-d13
regress lvc ly2-ly4 ly22 ly23 ly24 ly33 ly34 ly44 lz1 yr yrcd2 yrcd3 cd2 cd3 d2-d13

xtpcse lvc ly2-ly4 lz1 yr yrcd2 yrcd3 cd2 cd3 d2-d13, c(a) het
xtpcse lvc ly2-ly4 ly22 ly23 ly24 ly33 ly34 ly44 lz1 yr yrcd2 yrcd3 cd2 cd3 d2-d13, c(a) het

xtfrontier lvc ly2-ly4 lz1 yr yrcd2 yrcd3 cd2 cd3, ti cost 

qui reg lvc ly2-ly4 ly22 ly23 ly24 ly33 ly34 ly44 lz1 yr yrcd2 yrcd3 cd2 cd3
matrix b0 = e(b), .1, ln(e(rmse)^2) , .1
xtfrontier lvc ly2-ly4 ly22 ly23 ly24 ly33 ly34 ly44 lz1 yr yrcd2 yrcd3 cd2 cd3, ti cost from(b0, copy)

log close


